import 'package:flutter_backend/flutter_backend.dart';

class PostController extends Controller {
  createInstance() => PostController();

  index() async {
    var results = await db.get(table: "post");

    res.send({
      "success": true,
      "message": "No Data BosVX!",
      "data": results,
    });
  }

  getSingleData() async {
    var id = req.get("id");
    var results = await db.get(
      table: "post",
      where: [
        "id = $id",
      ],
    );

    res.send({
      "success": true,
      "message": "Get Single Data",
      "id": id,
      "data": results,
    });
  }

  create() async {
    await db.create(
      table: "post",
      field: {
        "title": post.get("title"),
        "content": post.get("content"),
      },
    );

    res.send({
      "success": true,
      "message": "Create Request",
      "request_body": post.postData,
    });
  }

  update() async {
    var id = req.get("id");

    await db.update(
      table: "post",
      field: {
        "title": post.get("title"),
        "content": post.get("content"),
      },
      where: [
        "id = $id",
      ],
    );

    res.send({
      "success": true,
      "message": "Update Request",
    });
  }

  delete() async {
    var id = req.get("id");
    await db.delete(
      table: "post",
      where: [
        "id=$id",
      ],
    );
    res.send({
      "success": true,
      "message": "Delete Request",
    });
  }
}
