library flutter_backend;

import 'dart:convert';
import 'dart:io';

import 'package:flutter_backend/shared/helper/db/db.dart';
import 'package:flutter_backend/shared/helper/request_helper/request_helper.dart';

extension NumberParsing on HttpRequest {
  String getParameters() {
    return "Bisa";
  }
}

class Request {
  List<Map<String, dynamic>> parameters;

  get(String key) {
    return parameters
        .where((item) => item["key"] == key)
        .toList()
        .first["value"];
  }
}

class Response {
  HttpResponse httpResponse;
  send(dynamic obj) {
    httpResponse
      ..statusCode = HttpStatus.ok
      ..headers.contentType = ContentType.json
      ..write(jsonEncode(obj));
    httpResponse.close();
  }
}

class PostRequestData {
  Map postData;

  get(String key) {
    return postData[key];
  }

  set(String key, dynamic value) {
    postData[key] = value;
  }
}

class Controller {
  HttpRequest httpRequest;
  // ignore: close_sinks
  HttpResponse httpResponse;
  List<Map<String, dynamic>> parameters;

  Request req;
  Response res;

  PostRequestData post;

  DB db;

  bind(RequestHelper rh) {
    this.httpRequest = rh.req;
    this.httpResponse = rh.res;

    this.req = Request();
    this.req.parameters = rh.parameters;

    this.res = Response();
    res.httpResponse = rh.res;

    this.db = DB();

    this.post = PostRequestData();
    this.post.postData = rh.postData;
  }

  index() {}
  getSingleData() {}
  create() {}
  update() {}
  delete() {}

  createInstance() {}
}
